<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Human-friendly time parser and formatter"><meta name="keywords" content="rust, rustlang, rust-lang, humantime"><title>humantime - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="../crates.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../humantime/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../humantime/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Crate humantime</a></h2><div class="sidebar-elems"><div class="block"><ul><li class="version">Version 2.1.0</li><li><a id="all-types" href="all.html">All Items</a></li></ul></div><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li><li><a href="#functions">Functions</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../humantime/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">humantime</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/humantime/lib.rs.html#1-34">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Human-friendly time parser and formatter</p>
<p>Features:</p>
<ul>
<li>Parses durations in free form like <code>15days 2min 2s</code></li>
<li>Formats durations in similar form <code>2years 2min 12us</code></li>
<li>Parses and formats timestamp in <code>rfc3339</code> format: <code>2018-01-01T12:53:00Z</code></li>
<li>Parses timestamps in a weaker format: <code>2018-01-01 12:53:00</code></li>
</ul>
<p>Timestamp parsing/formatting is super-fast because format is basically
fixed.</p>
<p>See <a href="https://docs.rs/humantime-serde">humantime-serde</a> for serde integration (previous crate <a href="https://docs.rs/serde-humantime/0.1.1/serde_humantime/">serde-humantime</a> looks unmaintained).</p>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Duration.html" title="humantime::Duration struct">Duration</a></div><div class="item-right docblock-short"><p>A wrapper for duration that has <code>FromStr</code> implementation</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FormattedDuration.html" title="humantime::FormattedDuration struct">FormattedDuration</a></div><div class="item-right docblock-short"><p>A wrapper type that allows you to Display a Duration</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Rfc3339Timestamp.html" title="humantime::Rfc3339Timestamp struct">Rfc3339Timestamp</a></div><div class="item-right docblock-short"><p>A wrapper type that allows you to Display a SystemTime</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Timestamp.html" title="humantime::Timestamp struct">Timestamp</a></div><div class="item-right docblock-short"><p>A wrapper for SystemTime that has <code>FromStr</code> implementation</p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.DurationError.html" title="humantime::DurationError enum">DurationError</a></div><div class="item-right docblock-short"><p>Error parsing human-friendly duration</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.TimestampError.html" title="humantime::TimestampError enum">TimestampError</a></div><div class="item-right docblock-short"><p>Error parsing datetime (timestamp)</p>
</div></div></div><h2 id="functions" class="small-section-header"><a href="#functions">Functions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.format_duration.html" title="humantime::format_duration fn">format_duration</a></div><div class="item-right docblock-short"><p>Formats duration into a human-readable string</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.format_rfc3339.html" title="humantime::format_rfc3339 fn">format_rfc3339</a></div><div class="item-right docblock-short"><p>Format an RFC3339 timestamp <code>2018-02-14T00:28:07Z</code></p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.format_rfc3339_micros.html" title="humantime::format_rfc3339_micros fn">format_rfc3339_micros</a></div><div class="item-right docblock-short"><p>Format an RFC3339 timestamp <code>2018-02-14T00:28:07.000000Z</code></p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.format_rfc3339_millis.html" title="humantime::format_rfc3339_millis fn">format_rfc3339_millis</a></div><div class="item-right docblock-short"><p>Format an RFC3339 timestamp <code>2018-02-14T00:28:07.000Z</code></p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.format_rfc3339_nanos.html" title="humantime::format_rfc3339_nanos fn">format_rfc3339_nanos</a></div><div class="item-right docblock-short"><p>Format an RFC3339 timestamp <code>2018-02-14T00:28:07.000000000Z</code></p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.format_rfc3339_seconds.html" title="humantime::format_rfc3339_seconds fn">format_rfc3339_seconds</a></div><div class="item-right docblock-short"><p>Format an RFC3339 timestamp <code>2018-02-14T00:28:07Z</code></p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.parse_duration.html" title="humantime::parse_duration fn">parse_duration</a></div><div class="item-right docblock-short"><p>Parse duration object <code>1hour 12min 5s</code></p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.parse_rfc3339.html" title="humantime::parse_rfc3339 fn">parse_rfc3339</a></div><div class="item-right docblock-short"><p>Parse RFC3339 timestamp <code>2018-02-14T00:28:07Z</code></p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.parse_rfc3339_weak.html" title="humantime::parse_rfc3339_weak fn">parse_rfc3339_weak</a></div><div class="item-right docblock-short"><p>Parse RFC3339-like timestamp <code>2018-02-14 00:28:07</code></p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="humantime" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>